{%- macro submission(submission, options) -%}
  {%- set options = {
    show_body: false,
    show_forum_name: true,
  }|merge(options|default({})) -%}

  {{- block('submission') -}}
{%- endmacro -%}

{%- macro submission_sort(current) -%}
  {%- spaceless -%}
  <nav class="submission-sort">
    <ul>
      {%- for type in ['hot', 'new', 'top', 'controversial'] -%}
        <li>
          <a href="{{ path(
              app.request.attributes.get('_route'),
              app.request.attributes.get('_route_params')|default([])|merge({sortBy: type}))
          }}" class="{{ type == current ? 'active' }}">
            {{- ('submissions.sort_by_'~type)|trans -}}
          </a>
        </li>
      {%- endfor -%}
    </ul>
  </nav>
  {%- endspaceless -%}
{%- endmacro -%}

{%- block submission_info_submitter -%}
  <a href="{{ path('raddit_app_user', {username: submission.user.username}) }}" class="submission-submitter">
    {{- submission.user.username -}}
  </a>
{%- endblock -%}

{%- block submission_info_timestamp -%}
  {%- set date = submission.timestamp|localizeddate('long', 'short') -%}
  <time datetime="{{ submission.timestamp|date('c') }}" title="{{ date }}" class="submission-timestamp relative-time">
    {{- 'submissions.info_at_timestamp'|trans({'%timestamp%': date}) -}}
  </time>
{%- endblock -%}

{%- block submission_info_forum_name -%}
  <a href="{{ path('raddit_app_forum', {forum_name: submission.forum.name}) }}" class="submission-forum">
    {{- submission.forum.name -}}
  </a>
{%- endblock -%}

{%- block submission -%}
  {%- from '@RadditApp/macros/votes.html.twig' import vote -%}
  <article class="submission {{ submission.url ? 'submission-has-url' }} {{ submission.body is not null ? 'submission-has-body' }} {{ not options.show_body ? 'submission-body-hidden' }}">
    <div class="submission-row">
      <div class="submission-vote">
        {{- vote(submission, path('raddit_app_submission_vote', {id: submission.id})) -}}
      </div>

      <div class="submission-inner">
        <header class="submission-header">
          {% spaceless %}
            <h1 class="submission-title">
              <a href="{{ block('submission_url') }}" class="submission-link">
                {{- submission.title -}}
              </a>
            </h1>
          {% endspaceless %}

          <p class="submission-info">
            {%- if options.show_forum_name -%}
              {{ 'submissions.info_with_forum_name'|trans({
                '%submitter%': block('submission_info_submitter'),
                '%timestamp%': block('submission_info_timestamp'),
                '%forum%': block('submission_info_forum_name'),
              })|raw }}
            {%- else -%}
              {{ 'submissions.info_without_forum_name'|trans({
                '%submitter%': block('submission_info_submitter'),
                '%timestamp%': block('submission_info_timestamp'),
              })|raw }}
            {%- endif -%}
          </p>
        </header>

        {%- if options.show_body -%}
          {% if submission.url %}
            <div class="submission-media">{{ block('submission_media') }}</div>
          {% endif %}

          {% if submission.body is not null %}
            <div class="submission-body">{{ submission.body|cached_markdown|raw }}</div>
          {% endif %}
        {%- endif -%}

        {%- spaceless -%}
          <nav class="submission-nav">
            <ul>
              <li>
                <a href="{{ path('raddit_app_comments', {forum_name: submission.forum.name, submission_id: submission.id}) }}">
                  {{- 'submissions.comments'|transchoice(submission.comments|length) -}}
                </a>
              </li>
              {%- if is_granted('edit', submission) -%}
                <li>
                  <a href="{{ path('raddit_app_edit_submission', {forum_name: submission.forum.name, submission_id: submission.id}) }}">
                    {{- 'submissions.edit'|trans -}}
                  </a>
                </li>
              {%- endif -%}
            </ul>
          </nav>
        {%- endspaceless -%}
      </div>
    </div>
  </article>
{% endblock %}

{%- block submission_url -%}
  {%- if submission.url -%}
    {{- submission.url -}}
  {%- else -%}
    {{- path('raddit_app_comments', {forum_name: submission.forum.name, submission_id: submission.id}) -}}
  {%- endif -%}
{%- endblock -%}

{%- block submission_media -%}
  {# TODO #}
{%- endblock -%}
